Rolling = {}
ClassSpecify = {}
ClassSpecify[0] = "none"
ClassSpecify[1] = "Plate"
ClassSpecify[2] = "Plate"
ClassSpecify[3] = "Chain"
ClassSpecify[4] = "Leather"
ClassSpecify[5] = "Cloth"
ClassSpecify[6] = "Plate"
ClassSpecify[7] = "Chain"
ClassSpecify[8] = "Cloth"
ClassSpecify[9] = "Cloth"
ClassSpecify[10] = "Leather"
ClassSpecify[11] = "Leather"
ClassSpecify[12] = "Leather"

Rollingcolor = {}
Rollingcolor[1] = "cffffff00"
Rollingcolor[2] = "cff0099ff"
Rollingcolor[3] = "cff663300"
Rollingcolor[4] = "cffdbc253"
Rollingcolor[5] = "cffdbc253"
Rollingcolor[6] = "cffdbc253"
Rollingcolor[7] = "cffdbc253"
Rollingcolor[8] = "cffdbc253"
Rollingcolor[9] = "cffdbc253"
Rollingcolor[10] = "cffdbc253"

local _, _, pc = UnitClass("player")
PlayerClass = ClassSpecify[pc]
PlayerNameOtherString = UnitName("player")
PlayerRealm = GetRealmName()
local fir = CreateFrame("Frame")
local name, addon = ...
local loginin = true
version = GetAddOnMetadata(name, "Version")
local _rollMessageTailRegex = RANDOM_ROLL_RESULT:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%d", "(%%d+)"):gsub("%%%d+%$d", "(%%d+)"):gsub("%%s", ""):gsub("%%%d+%$s", "").. "$"


function spairs(t, order)
    if not t then return end
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end

function BiggerUIUpdate()
    local loopcount = 1
    for i, v in spairs(playerroll, function(t,a,b) return t[b] < t[a] end) do
        if loopcount <= 9 then
            local _, _, _, _, _, name, realm = GetPlayerInfoByGUID(UnitGUID(i))
            if realm == "" or realm == nil then
                realm = PlayerRealm
            end

            BiggerGUI.name[''..loopcount]:SetText('|'..Rollingcolor[loopcount]..'['..loopcount..'] |cffdbc253'..name.."-"..realm)
            BiggerGUI.Roll[''..loopcount]:SetText('|cffdbc253'.. v)
            BiggerGUI.ILvL[''..loopcount]:SetText('|cffdbc253---')
            BiggerGUI.Rasse[''..loopcount]:SetText('|cffdbc253'.. ClassSpecify[select(3, UnitClass(name))])
            loopcount = loopcount + 1
        end
    end
end

function BiggerUIClear()
    for i=1, 9 do
        BiggerGUI.name[''..i]:SetText("")
        BiggerGUI.Roll[''..i]:SetText("")
        BiggerGUI.ILvL[''..i]:SetText("")
        BiggerGUI.Rasse[''..i]:SetText("")
    end
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function itsitem(message)
    local result = select(3, string.find(string.lower(message), "roll (|.+|r)"))
    if not result then
        result = select(3, string.find(string.lower(message), "(|.+|r) roll"))
    end
    if not result then
        result = select(3, string.find(string.lower(message), "roll for (|.+|r)"))
    end
    if not result then
        result = select(3, string.find(string.lower(message), "someone need (|.+|r)"))
    end
    if not result then
        result = select(3, string.find(string.lower(message), "someone want (|.+|r)"))
    end
    if not result then
        result = select(3, string.find(string.lower(message), "(|.+|r) someone"))
    end
    if not result then
        return false
    else
        return select(3, string.find(message, "(|.+|r)"))
    end
end

fir:RegisterEvent("ADDON_LOADED")
fir:RegisterEvent("PLAYER_LOGIN")
fir:RegisterEvent("CHAT_MSG_PARTY")
fir:RegisterEvent("CHAT_MSG_PARTY_LEADER")
fir:RegisterEvent("CHAT_MSG_RAID")
fir:RegisterEvent("CHAT_MSG_RAID_LEADER")
fir:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
fir:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
fir:SetScript("OnEvent",function(self,event,...)
    if(loginin == true and ((event == "ADDON_LOADED" and name == arg1) or (event == "PLAYER_LOGIN"))) then
        loginin = nil
        if not RollingI then RollingI = { } end
        if not RollingI.Version then RollingI.Version = version end
        if not RollingI.XPos then RollingI.XPos = 0 end
        if not RollingI.YPos then RollingI.YPos = 0 end
        if not RollingI.BiggerUIXPos then RollingI.BiggerUIXPos = 0 end
        if not RollingI.BiggerUIYPos then RollingI.BiggerUIYPos = 0 end
        if not RollingI.Default then RollingI.Default = {} end
        if not RollingI.Default.WinChat then RollingI.Default.WinChat = "%p won %i by Rolling with number %n." end
        if not RollingI.Default.Start then RollingI.Default.Start = "Roll %i." end
        if not RollingI.Default.Cancel then RollingI.Default.Cancel = "Sorry. it was a mistake. I cancel the roll!" end
        if not RollingI.Default.CancelMessage then RollingI.Default.CancelMessage = false end
        if not RollingI.Default.Timer then RollingI.Default.Timer = 3 end
        if not RollingI.Default.TimerCount then RollingI.Default.TimerCount = false end
        if not RollingI.WinChat then RollingI.WinChat = RollingI.Default.WinChat end
        if not RollingI.Start then RollingI.Start = RollingI.Default.Start end
        if not RollingI.CancelMessage then RollingI.CancelMessage = RollingI.Default.CancelMessage end
        if not RollingI.Cancel then RollingI.Cancel = RollingI.Default.Cancel end
        if not RollingI.TimerCount then RollingI.TimerCount = RollingI.Default.TimerCount end
        if not RollingI.Timer then RollingI.Timer = RollingI.Default.Timer end
        if not RollingI.Debugbutton then RollingI.Debugbutton = false end
        if RollingI.Version ~= version then print("|cff00ccff[Rolling]|cffe2bd16 Updating") print("|cff00ccff[Rolling]|cffe2bd16 Updating Finished.") RollingI.Version = version end
        fr:ClearAllPoints()
        fr:SetPoint("BOTTOMLEFT", RollingI.XPos, RollingI.YPos)
        framegui:ClearAllPoints()
        framegui:SetPoint("BOTTOMLEFT", RollingI.BiggerUIXPos, RollingI.BiggerUIYPos)
        tinsert(UISpecialFrames, framegui:GetName())
    elseif event == "CHAT_MSG_SYSTEM" then
        if rolling == true then
            local msg, arg1 = ...
            if msg then
                local roll, min, max = msg:match(_rollMessageTailRegex)
                local name = msg:gsub("%s*" .. _rollMessageTailRegex, "")
                roll = tonumber(roll)
                min = tonumber(min)
                max = tonumber(max)
                if roll then
                    if roll and (min == 1 or min == 0) and max == 100 then
                        if not playerroll then playerroll = {} end
                        if not playerroll[name] then
                            playerroll[name] = roll
                            looptimer = 1
                            message = ""
                            for i, v in spairs(playerroll, function(t,a,b) return t[b] < t[a] end) do
                                if looptimer <= 3 then
                                    if classcheck == true then
                                        if ClassSpecify[select(3, UnitClass(i))] ~= PlayerClass then
                                            fr.txt[looptimer]:SetText("|cFFFF0000Not specify Class item.")
                                        else
                                            fr.txt[looptimer]:SetText("")
                                        end
                                    end
                                    message = message.."|"..Rollingcolor[looptimer].."["..looptimer.."] |cff0099ff"..i.." |cffffff00 rolled a |cff0099ff"..v.."\n\n"
                                    looptimer = looptimer + 1
                                end
                            end
                            BiggerUIUpdate()
                            fr.text:SetText(message)
                            fr:Show()
                        else
                            print("|cFFFF0000"..name.. " tried to rolling twice.")
                        end
                    else
                        print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..") Max: ("..max..")")
                    end
                end
            end
        elseif otherroll then
            local msg, arg1 = ...
            if msg then
                local roll, min, max = msg:match(_rollMessageTailRegex)
                local name = msg:gsub("%s*" .. _rollMessageTailRegex, "")
                roll = tonumber(roll)
                min = tonumber(min)
                max = tonumber(max)
                if roll then
                    if roll and (min == 1 or min == 0) and max == 100 then
                        if not playerroll then playerroll = {} end
                        if not playerroll[name] then
                            playerroll[name] = roll
                            looptimer = 1
                            message = ""
                            for i, v in spairs(playerroll, function(t,a,b) return t[b] < t[a] end) do
                                if looptimer <= 3 then
                                    if classcheck == true then
                                        if ClassSpecify[select(3, UnitClass(i))] ~= otherplayerspec then
                                            fr.txt[looptimer]:SetText("|cFFFF0000Not specify Class item.")
                                        else
                                            fr.txt[looptimer]:SetText("")
                                        end
                                    end
                                    message = message.."|"..Rollingcolor[looptimer].."["..looptimer.."] |cff0099ff"..i.." |cffffff00 rolled a |cff0099ff"..v.."\n\n"
                                    looptimer = looptimer + 1
                                end
                            end
                            BiggerUIUpdate()
                            fr.text:SetText(message)
                            fr:Show()
                        else
                            print("|cFFFF0000"..name.. " tried to rolling twice.")
                        end
                    else
                        print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..") Max: ("..max..")")
                    end
                end
            end
        elseif RollingTwice then
            local msg, arg1 = ...
            if msg then
                local roll, min, max = msg:match(_rollMessageTailRegex)
                local name = msg:gsub("%s*" .. _rollMessageTailRegex, "")
                roll = tonumber(roll)
                min = tonumber(min)
                max = tonumber(max)
                if roll then
                    if RollingTwice[name] and RollingTwice[name] == true then
                        RollingTwice[name] = nil
                        if not playerroll then playerroll = {} end
                        playerroll[name] = roll
                        looptimer = 1
                        message = ""
                        for i, v in spairs(playerroll, function(t,a,b) return t[b] < t[a] end) do
                            if looptimer <= 3 then
                                if classcheck == true then
                                    if ClassSpecify[select(3, UnitClass(i))] ~= PlayerClass then
                                        fr.txt[looptimer]:SetText("|cFFFF0000Not specify Class item.")
                                    else
                                        fr.txt[looptimer]:SetText("")
                                    end
                                end
                                message = message.."|"..Rollingcolor[looptimer].."["..looptimer.."] |cff0099ff"..i.." |cffffff00 rolled a |cff0099ff"..v.."\n\n"
                                looptimer = looptimer + 1
                            end
                        end
                        if tablelength(RollingTwice) == 0 then
                            C_Timer.After(1, function() finish() end)
                        end
                        BiggerUIUpdate()
                        fr.text:SetText(message)
                        fr:Show()
                    end

                end
            end
        end
    elseif event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_PARTY_LEADER" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_INSTANCE_CHAT" or event == "CHAT_MSG_INSTANCE_CHAT_LEADER" then
        local player = select(2, ...)
        if select(1, strsplit("-", player)) ~= PlayerNameOtherString then
            local item = itsitem(select(1, ...)) 
            if item then
                if not otherroll then
                    startandcheck(player, item)
                end
            end
        end
    end
end)

function getslotid(message)
    local name = select(2, strsplit("_", message))
    if name == "CLOAK" then
        name = "Back"
    elseif name == "WEAPON" or name == "WEAPONMAINHAND" then
        name = "MainHand"
    elseif name == "2HWEAPON" or name =="SHIELD" or name == "WEAPONOFFHAND" or name == "HOLDABLE" then
        name = "SecondaryHand"
    elseif name == "FINGER" then
        name = "Finger0"
    elseif name == "TRINKET" then
        name = "Trinket0"
    elseif name == "HAND" then
        name = "HANDS"
    end
    return GetInventorySlotInfo(name.."Slot")
end

function startandcheck(startandcheckplayer, iitem)
    local itemm, _, _, ilvl, _, _, _, _, ItemLoc, icon = GetItemInfo(iitem)
    if itemm then
        if ItemLoc == "INVTYPE_AMMO" or ItemLoc == "INVTYPE_HEAD" or ItemLoc == "INVTYPE_NECK" or ItemLoc == "INVTYPE_SHOULDER" or ItemLoc == "INVTYPE_BODY" or ItemLoc == "INVTYPE_CHEST" or ItemLoc == "INVTYPE_ROBE" or ItemLoc == "INVTYPE_WAIST" or ItemLoc == "INVTYPE_LEGS" or ItemLoc == "INVTYPE_FEET" or ItemLoc == "INVTYPE_WRIST" or ItemLoc == "INVTYPE_HAND" or ItemLoc == "INVTYPE_FINGER" or ItemLoc == "INVTYPE_TRINKET" or ItemLoc == "INVTYPE_CLOAK" or ItemLoc == "INVTYPE_WEAPON" or ItemLoc == "INVTYPE_SHIELD" or ItemLoc == "INVTYPE_2HWEAPON" or ItemLoc == "INVTYPE_WEAPONMAINHAND" or ItemLoc == "INVTYPE_WEAPONOFFHAND" or ItemLoc == "INVTYPE_HOLDABLE" or ItemLoc == "INVTYPE_RANGED" or ItemLoc == "INVTYPE_THROWN" or ItemLoc == "INVTYPE_RANGEDRIGHT" or ItemLoc == "INVTYPE_RELIC" or ItemLoc == "INVTYPE_TABARD" or ItemLoc == "INVTYPE_BAG" or ItemLoc == "INVTYPE_QUIVER" then
            local myitem = GetInventoryItemLink("player", getslotid(ItemLoc))
            if myitem then
                _, _, _, myilvl = GetItemInfo(myitem)
            else
                myilvl = 0
            end
            if myilvl <= ilvl then
                if not ItemLoc == "INVTYPE_FINGER" or not ItemLoc == "INVTYPE_TRINKET" or not ItemLoc == "INVTYPE_CLOAK" then
                    if ClassSpecify[select(3, UnitClass(startandcheckplayer))] == PlayerClass then
                        clear("a")
                        classcheck = true
                        otherplayerspec = ClassSpecify[select(3, UnitClass(startandcheckplayer))]
                        fr.icon.overlay:SetTexture(icon)
                        item = iitem
                        otherroll = true
                        fr.txt4:SetText(tostring(iitem))
                        fir:RegisterEvent("CHAT_MSG_SYSTEM")
                        fr.ennd:Hide()
                        fr.cancel:Hide()
                        fr.recommendb:Hide()
                        fr.timer:SetText(startandcheckplayer)
                        fr.finishend:Show()
                        fr:Show()
                        if not RollingI.FirstTime then
                            print("|cff00ccff[Rolling]|cffe2bd16 I will tell you one time! This UI pop out only if someone other people wanted to roll thier Items AND IF YOU NEED THEM! (Better ILvl)")
                            print("|cffe2bd16SoIf the player already trade with other players, please close the UI so you can get the other Rolls too.")
                            print("")
                            RollingI.FirstTime = true
                        end
                        print("|cff00ccff[Rolling]|cffe2bd16 There is a item, that you could needed.")
                    else
                        if RollingI.Debugbutton == true then
                            print("|cff00ccff[Rolling]|cffe2bd16 This roll has been responds, but not matched Class.")
                        end
                    end
                else
                    clear("a")
                    fr.icon.overlay:SetTexture(icon)
                    item = iitem
                    otherroll = true
                    fr.txt4:SetText(tostring(iitem))
                    fir:RegisterEvent("CHAT_MSG_SYSTEM")
                    fr.ennd:Hide()
                    fr.cancel:Hide()
                    fr.recommendb:Hide()
                    fr.timer:SetText(startandcheckplayer)
                    fr.finishend:Show()
                    fr:Show()
                    if not RollingI.FirstTime then
                        print("|cff00ccff[Rolling]|cffe2bd16 I will tell you one time! This UI pop out only if someone other people wanted to roll thier Items AND IF YOU NEED THEM! (Better ILvl)")
                        print("|cffe2bd16So if the player already trade with other players, please close the UI so you can get the other Rolls too.")
                        print("")
                        RollingI.FirstTime = true
                    end
                    print("|cff00ccff[Rolling]|cffe2bd16 There is a item, that you could needed.")
                end
            else
                if RollingI.Debugbutton == true then
                    print("|cff00ccff[Rolling]|cffe2bd16 This roll has been responds, but low ILevel.")
                end
            end
        end
    end
end

function finish()
    if rolling == true or RollingTwice then
        local PlacingName = {}
        local PlacingRoll = {}
        if playerroll then
            looptimer = 0
            for i, v in spairs(playerroll, function(t,a,b) return t[b] < t[a] end) do
                looptimer = looptimer + 1
                PlacingName[looptimer] = i
                PlacingRoll[looptimer] = v
            end
            if PlacingRoll[1] == PlacingRoll[2] then
                SendChatMessage("2 Players got the same Number. fail!", group)
                SendChatMessage("Please Roll again, "..PlacingName[1].." and "..PlacingName[2], group)
                clear("Twice")
                RollingTwice = {}
                RollingTwice[PlacingName[1]] = true
                RollingTwice[PlacingName[2]] = true
                if PlacingRoll[2] == PlacingRoll[3] then
                    print("3... same roll. lamo")
                end
            else
                local text = RollingI.WinChat:gsub("%%i", item)
                local text = text:gsub("%%p", PlacingName[1])
                local text = text:gsub("%%n", PlacingRoll[1])
                SendChatMessage(text.." Addons by 'Rolling Manager'", group)
                clear("a")
                fr:Hide()
            end
        else
            clear("a")
            fr:Hide()
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

local function cancel()
    if rolling == true then
        if RollingI.CancelMessage then
            SendChatMessage(RollingI.Cancel .." Addons by 'Rolling Manager'", group)
        end
        clear()
        fr:Hide()
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

function clear(text)
    if not text == "Twice" then
        fir:UnregisterEvent("CHAT_MSG_SYSTEM")
        fr.icon.overlay:SetTexture(GetItemIcon(6948))
        classcheck = nil
        fr.txt4:SetText("")
        item = nil
    elseif not text then
        print("|cff00ccff[Rolling] |cFFFF0000Clear session.")
        fir:UnregisterEvent("CHAT_MSG_SYSTEM")
        fr.icon.overlay:SetTexture(GetItemIcon(6948))
        classcheck = nil
        fr.txt4:SetText("")
        item = nil
    end
    myilvl = nil
    otherplayerspec = nil
    fr.finishend:Hide()
    RollingTwice = nil
    otherroll = nil
    fr.timer:SetText("")
    fr.text:SetText("")
    fr.txt[1]:SetText("")
    fr.txt[2]:SetText("")
    fr.txt[3]:SetText("")
    fr.recommend:SetText("")
    fr.recommended:SetText("")
    fr.ennd:Show()
    fr.cancel:Show()
    fr.recommendb:Show()
    rolling = false
    looprest = nil
    number = nil
    playerroll = nil
    if BiggerGUI then
        BiggerUIClear()
    end
end

local function looptimer (n)
    if n then
        looprest = tonumber(n)
    end
    if looprest == 0 then
        finish()
    else
        if RollingI.TimerCount == true then
            fr.timer:SetText("Timer: "..looprest)
            if looprest <= RollingI.Timer then
                SendChatMessage(looprest.."...", group)
            end
        end
        looprest = looprest - 1
        C_Timer.After(1, looptimer)
    end
end

fr.ennd:SetScript("OnClick", function()
    finish()
end)

fr.cancel:SetScript("OnClick", function()
    cancel()
end)

fr.recommendb:SetScript("OnClick", function()
    framegui:Show()
end)



clear()

SLASH_ROLLING1 = "/rr"
SlashCmdList["ROLLING"] = function(msg)
    local arg, arg1, arg2 = strsplit(" ", msg, 3)
    bla = nil
    if arg ~= nil then
        if arg == "roll" then
            clear("a")
            if tonumber(arg1) then
                bla = arg2
                number = arg1
            elseif arg1 ~= nil then
                _, bla = strsplit(" ", msg, 2)
            end
            if bla ~= nil then
                local itemm, _, _, _, _, _, _, _, ItemLoc = GetItemInfo(bla)
                if itemm then
                    if ItemLoc == "INVTYPE_AMMO" or ItemLoc == "INVTYPE_HEAD" or ItemLoc == "INVTYPE_NECK" or ItemLoc == "INVTYPE_SHOULDER" or ItemLoc == "INVTYPE_BODY" or ItemLoc == "INVTYPE_CHEST" or ItemLoc == "INVTYPE_ROBE" or ItemLoc == "INVTYPE_WAIST" or ItemLoc == "INVTYPE_LEGS" or ItemLoc == "INVTYPE_FEET" or ItemLoc == "INVTYPE_WRIST" or ItemLoc == "INVTYPE_HAND" or ItemLoc == "INVTYPE_FINGER" or ItemLoc == "INVTYPE_TRINKET" or ItemLoc == "INVTYPE_CLOAK" or ItemLoc == "INVTYPE_WEAPON" or ItemLoc == "INVTYPE_SHIELD" or ItemLoc == "INVTYPE_2HWEAPON" or ItemLoc == "INVTYPE_WEAPONMAINHAND" or ItemLoc == "INVTYPE_WEAPONOFFHAND" or ItemLoc == "INVTYPE_HOLDABLE" or ItemLoc == "INVTYPE_RANGED" or ItemLoc == "INVTYPE_THROWN" or ItemLoc == "INVTYPE_RANGEDRIGHT" or ItemLoc == "INVTYPE_RELIC" or ItemLoc == "INVTYPE_TABARD" or ItemLoc == "INVTYPE_BAG" or ItemLoc == "INVTYPE_QUIVER" then
                        if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
                            group = "INSTANCE_CHAT"
                        elseif IsInRaid(0) then
                            group = "RAID"
                        elseif IsInGroup(0) then
                            group = "PARTY"
                        end
                        --group = "SAY"
                        if group then
                            if not ItemLoc == "INVTYPE_FINGER" or not ItemLoc == "INVTYPE_TRINKET" or not ItemLoc == "INVTYPE_CLOAK" then
                                classcheck = true
                            end
                            fr.icon.overlay:SetTexture(GetItemIcon(itemm))
                            rolling = true
                            item = bla
                            fr.txt4:SetText(tostring(item))
                            fir:RegisterEvent("CHAT_MSG_SYSTEM")
                            print("|cff00ccff[Rolling] |cFF00FF00Rolling started!")
                            local text1 = RollingI.Start:gsub("%%i", bla)
                            SendChatMessage(text1, group)
                            if number then
                                looptimer(tonumber(number))
                            end
                        else
                            print("|cFFFF0000You can't start a roll without a Party or Raid.")
                        end
                    else
                        print("|cff00ccff[Rolling] |cFFFF0000You can't roll this item!")
                    end

                else
                    print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [number] <Link>'")
                end
            else
                print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [number] <Link>'")
            end
        elseif arg == "finish" or arg == "end" then
            finish()
        elseif arg == "cancel" then
            cancel()
        elseif arg == "show" then
            fr:Show()
        end
    end
end