fr = CreateFrame("Frame", "Rolling_Frame", UIParent, "BasicFrameTemplateWithInset")
fr:ClearAllPoints()
fr:SetSize(300, 230)
fr:SetPoint("CENTER", UIParent, "CENTER")
fr:SetMovable(true)
fr:EnableMouse(true)
fr:SetUserPlaced(true)
fr:SetScript("OnMouseDown", fr.StartMoving)
fr:SetScript("OnMouseUp", function (self)
    fr:StopMovingOrSizing()
    RollingI.XPos = self:GetLeft()
    RollingI.YPos = self:GetBottom()
end)
fr:SetScript("OnHide", function (self)
	if otherroll then
		fr:Hide()
    	clear("a")
	end
end)

fr.ennd = CreateFrame("Button", nil, fr, "GameMenuButtonTemplate")
fr.ennd:SetPoint("Right", fr, "TOP", -50, -200)
fr.ennd:SetSize(80, 20)
fr.ennd:SetText("End")
fr.ennd:RegisterForClicks("AnyUp")

fr.cancel = CreateFrame("Button", nil, fr, "GameMenuButtonTemplate")
fr.cancel:SetPoint("LEFT", fr, "TOP", 50, -200)
fr.cancel:SetSize(80, 20)
fr.cancel:SetText("Cancel")
fr.cancel:RegisterForClicks("AnyUp")

fr.recommendb = CreateFrame("Button", nil, fr, "GameMenuButtonTemplate")
fr.recommendb:SetPoint("CENTER", fr, "TOP", 0, -200)
fr.recommendb:SetSize(90, 20)
fr.recommendb:SetText("Bigger UI")
fr.recommendb:RegisterForClicks("AnyUp")

fr.finishend = CreateFrame("Button", nil, fr, "GameMenuButtonTemplate")
fr.finishend:SetPoint("Right", fr, "TOP", 130, -200)
fr.finishend:SetSize(260, 20)
fr.finishend:SetText("Close / Finish")
fr.finishend:RegisterForClicks("AnyUp")

fr.title = fr:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
fr.title:SetPoint("LEFT", fr.TitleBg, "LEFT", 5, 0)
fr.title:SetText("Rolling")

fr.timer = fr:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
fr.timer:SetPoint("LEFT", fr.TitleBg, "LEFT", 150, 0)

fr.recommend = fr:CreateFontString(nil, "ARTWORK")
fr.recommend:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
fr.recommend:SetPoint("TOPLEFT", 10, -30)
fr.recommend:SetJustifyH("LEFT")

fr.recommended = fr:CreateFontString(nil, "ARTWORK")
fr.recommended:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
fr.recommended:SetPoint("TOPLEFT", 10, -50)
fr.recommended:SetJustifyH("LEFT")

fr.text = fr:CreateFontString(nil, "ARTWORK")
fr.text:SetFont("Fonts\\ARIALN.ttf", 18, "OUTLINE")
fr.text:SetPoint("TOPLEFT", 10, -80)
fr.text:SetJustifyH("LEFT")

fr.txt = {}

fr.txt[1] = fr:CreateFontString(nil, "ARTWORK")
fr.txt[1]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
fr.txt[1]:SetPoint("TOPLEFT", 10, -99)
fr.txt[1]:SetJustifyH("LEFT")

fr.txt[2] = fr:CreateFontString(nil, "ARTWORK")
fr.txt[2]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
fr.txt[2]:SetPoint("TOPLEFT", 10, -135)
fr.txt[2]:SetJustifyH("LEFT")

fr.txt[3] = fr:CreateFontString(nil, "ARTWORK")
fr.txt[3]:SetFont("Fonts\\ARIALN.ttf", 14, "OUTLINE")
fr.txt[3]:SetPoint("TOPLEFT", 10, -170)
fr.txt[3]:SetJustifyH("LEFT")
--fr.text:SetText("|cffffff00[1] |cff0099ffPLAYER 1|cffffff00 Rolled a |cff0099ff90\n\n|cff669999[2] |cff0099ffPLAYER 2 |cff669999 Rolled a |cff0099ff89\n\n|cff663300[3] |cff0099ffPLAYER 3|cff663300 Rolled a |cff0099ff88")

fr.txt4 = fr:CreateFontString(nil, "ARTWORK")
fr.txt4:SetFont("Fonts\\ARIALN.ttf", 16, "OUTLINE")
fr.txt4:SetPoint("TOPLEFT", 50, -45)
fr.txt4:SetJustifyH("LEFT")

fr.icon = CreateFrame("Button", nil, fr, "GameMenuButtonTemplate")
fr.icon:SetPoint("Right", fr, "TOP", -100, -55)
fr.icon:SetSize(40, 40)
fr.icon.overlay = fr.icon:CreateTexture(nil, "OVERLAY")
fr.icon.overlay:SetPoint("Right", fr, "TOP", -100, -55)
fr.icon.overlay:SetSize(40, 40)
fr.icon.overlay:SetTexture(GetItemIcon(6948))
fr.icon:SetScript("OnEnter", function(self) 
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:ClearLines()
	--local id = GetItemInfoInstant(item)
	if item then
		local _, id = GetItemInfo(tostring(item))
		--GameTooltip:SetItemByID(id)
		GameTooltip:SetHyperlink(id)
	else
		local _, id = GetItemInfo("Ruhestein")
		GameTooltip:SetHyperlink(id)
	end
	GameTooltip:Show() 
end)
fr.icon:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
fr.icon:Show()

fr:Hide()